## Ms Basic Connect V2 service

Ms Basic Connect V2 service — Support for the Ms Basic Connect V2 service.

## Functions

void | mbim_rsrp_snr_info_array_free ()
gboolean | mbim_message_ms_basic_connect_v2_register_state_response_parse ()
gboolean | mbim_message_ms_basic_connect_v2_register_state_notification_parse ()
gboolean | mbim_message_ms_basic_connect_v2_packet_service_response_parse ()
gboolean | mbim_message_ms_basic_connect_v2_packet_service_notification_parse ()
gboolean | mbim_message_ms_basic_connect_v2_signal_state_response_parse ()
gboolean | mbim_message_ms_basic_connect_v2_signal_state_notification_parse ()

## Types and Values

| MbimRsrpSnrInfo
typedef | MbimRsrpSnrInfoArray

## Description

This section implements support for requests, responses and notifications in the Ms Basic Connect V2 service.

## Functions

### mbim_rsrp_snr_info_array_free ()

    void
    mbim_rsrp_snr_info_array_free (MbimRsrpSnrInfoArray *array);

Frees the memory allocated for the array of MbimRsrpSnrInfo structs.

#### Parameters

array | a NULL terminated array of MbimRsrpSnrInfo structs. |

Since: 1.28

### mbim_message_ms_basic_connect_v2_register_state_response_parse ()

    gboolean
    mbim_message_ms_basic_connect_v2_register_state_response_parse
                                   (const MbimMessage *message,
                                    MbimNwError *out_nw_error,
                                    MbimRegisterState *out_register_state,
                                    MbimRegisterMode *out_register_mode,
                                    MbimDataClass *out_available_data_classes,
                                    MbimCellularClass *out_current_cellular_class,
                                    gchar **out_provider_id,
                                    gchar **out_provider_name,
                                    gchar **out_roaming_text,
                                    MbimRegistrationFlag *out_registration_flag,
                                    MbimDataClass *out_preferred_data_classes,
                                    GError **error);

Parses and returns parameters of the 'Register State' response command in the 'Ms Basic Connect V2' service.

#### Parameters

message | the MbimMessage. |
out_nw_error | return location for a MbimNwError, or `NULL` if the 'NwError' field is not needed. | [out][optional][transfer none]
out_register_state | return location for a MbimRegisterState, or `NULL` if the 'RegisterState' field is not needed. | [out][optional][transfer none]
out_register_mode | return location for a MbimRegisterMode, or `NULL` if the 'RegisterMode' field is not needed. | [out][optional][transfer none]
out_available_data_classes | return location for a MbimDataClass, or `NULL` if the 'AvailableDataClasses' field is not needed. | [out][optional][transfer none]
out_current_cellular_class | return location for a MbimCellularClass, or `NULL` if the 'CurrentCellularClass' field is not needed. | [out][optional][transfer none]
out_provider_id | return location for a newly allocated string, or `NULL` if the 'ProviderId' field is not needed. Free the returned value with `g_free()`. | [out][optional][transfer full]
out_provider_name | return location for a newly allocated string, or `NULL` if the 'ProviderName' field is not needed. Free the returned value with `g_free()`. | [out][optional][transfer full]
out_roaming_text | return location for a newly allocated string, or `NULL` if the 'RoamingText' field is not needed. Free the returned value with `g_free()`. | [out][optional][transfer full]
out_registration_flag | return location for a MbimRegistrationFlag, or `NULL` if the 'RegistrationFlag' field is not needed. | [out][optional][transfer none]
out_preferred_data_classes | return location for a MbimDataClass, or `NULL` if the 'PreferredDataClasses' field is not needed. | [out][optional][transfer none]
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.28

### mbim_message_ms_basic_connect_v2_register_state_notification_parse ()

    gboolean
    mbim_message_ms_basic_connect_v2_register_state_notification_parse
                                   (const MbimMessage *message,
                                    MbimNwError *out_nw_error,
                                    MbimRegisterState *out_register_state,
                                    MbimRegisterMode *out_register_mode,
                                    MbimDataClass *out_available_data_classes,
                                    MbimCellularClass *out_current_cellular_class,
                                    gchar **out_provider_id,
                                    gchar **out_provider_name,
                                    gchar **out_roaming_text,
                                    MbimRegistrationFlag *out_registration_flag,
                                    MbimDataClass *out_preferred_data_classes,
                                    GError **error);

Parses and returns parameters of the 'Register State' notification command in the 'Ms Basic Connect V2' service.

#### Parameters

message | the MbimMessage. |
out_nw_error | return location for a MbimNwError, or `NULL` if the 'NwError' field is not needed. | [out][optional][transfer none]
out_register_state | return location for a MbimRegisterState, or `NULL` if the 'RegisterState' field is not needed. | [out][optional][transfer none]
out_register_mode | return location for a MbimRegisterMode, or `NULL` if the 'RegisterMode' field is not needed. | [out][optional][transfer none]
out_available_data_classes | return location for a MbimDataClass, or `NULL` if the 'AvailableDataClasses' field is not needed. | [out][optional][transfer none]
out_current_cellular_class | return location for a MbimCellularClass, or `NULL` if the 'CurrentCellularClass' field is not needed. | [out][optional][transfer none]
out_provider_id | return location for a newly allocated string, or `NULL` if the 'ProviderId' field is not needed. Free the returned value with `g_free()`. | [out][optional][transfer full]
out_provider_name | return location for a newly allocated string, or `NULL` if the 'ProviderName' field is not needed. Free the returned value with `g_free()`. | [out][optional][transfer full]
out_roaming_text | return location for a newly allocated string, or `NULL` if the 'RoamingText' field is not needed. Free the returned value with `g_free()`. | [out][optional][transfer full]
out_registration_flag | return location for a MbimRegistrationFlag, or `NULL` if the 'RegistrationFlag' field is not needed. | [out][optional][transfer none]
out_preferred_data_classes | return location for a MbimDataClass, or `NULL` if the 'PreferredDataClasses' field is not needed. | [out][optional][transfer none]
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.28

### mbim_message_ms_basic_connect_v2_packet_service_response_parse ()

    gboolean
    mbim_message_ms_basic_connect_v2_packet_service_response_parse
                                   (const MbimMessage *message,
                                    guint32 *out_nw_error,
                                    MbimPacketServiceState *out_packet_service_state,
                                    MbimDataClass *out_current_data_class,
                                    guint64 *out_uplink_speed,
                                    guint64 *out_downlink_speed,
                                    MbimFrequencyRange *out_frequency_range,
                                    GError **error);

Parses and returns parameters of the 'Packet Service' response command in the 'Ms Basic Connect V2' service.

#### Parameters

message | the MbimMessage. |
out_nw_error | return location for a guint32, or `NULL` if the 'NwError' field is not needed. | [out][optional][transfer none]
out_packet_service_state | return location for a MbimPacketServiceState, or `NULL` if the 'PacketServiceState' field is not needed. | [out][optional][transfer none]
out_current_data_class | return location for a MbimDataClass, or `NULL` if the 'CurrentDataClass' field is not needed. | [out][optional][transfer none]
out_uplink_speed | return location for a guint64, or `NULL` if the 'UplinkSpeed' field is not needed. | [out][optional][transfer none]
out_downlink_speed | return location for a guint64, or `NULL` if the 'DownlinkSpeed' field is not needed. | [out][optional][transfer none]
out_frequency_range | return location for a MbimFrequencyRange, or `NULL` if the 'FrequencyRange' field is not needed. | [out][optional][transfer none]
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.28

### mbim_message_ms_basic_connect_v2_packet_service_notification_parse ()

    gboolean
    mbim_message_ms_basic_connect_v2_packet_service_notification_parse
                                   (const MbimMessage *message,
                                    guint32 *out_nw_error,
                                    MbimPacketServiceState *out_packet_service_state,
                                    MbimDataClass *out_current_data_class,
                                    guint64 *out_uplink_speed,
                                    guint64 *out_downlink_speed,
                                    MbimFrequencyRange *out_frequency_range,
                                    GError **error);

Parses and returns parameters of the 'Packet Service' notification command in the 'Ms Basic Connect V2' service.

#### Parameters

message | the MbimMessage. |
out_nw_error | return location for a guint32, or `NULL` if the 'NwError' field is not needed. | [out][optional][transfer none]
out_packet_service_state | return location for a MbimPacketServiceState, or `NULL` if the 'PacketServiceState' field is not needed. | [out][optional][transfer none]
out_current_data_class | return location for a MbimDataClass, or `NULL` if the 'CurrentDataClass' field is not needed. | [out][optional][transfer none]
out_uplink_speed | return location for a guint64, or `NULL` if the 'UplinkSpeed' field is not needed. | [out][optional][transfer none]
out_downlink_speed | return location for a guint64, or `NULL` if the 'DownlinkSpeed' field is not needed. | [out][optional][transfer none]
out_frequency_range | return location for a MbimFrequencyRange, or `NULL` if the 'FrequencyRange' field is not needed. | [out][optional][transfer none]
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.28

### mbim_message_ms_basic_connect_v2_signal_state_response_parse ()

    gboolean
    mbim_message_ms_basic_connect_v2_signal_state_response_parse
                                   (const MbimMessage *message,
                                    guint32 *out_rssi,
                                    guint32 *out_error_rate,
                                    guint32 *out_signal_strength_interval,
                                    guint32 *out_rssi_threshold,
                                    guint32 *out_error_rate_threshold,
                                    guint32 *out_rsrp_snr_count,
                                    MbimRsrpSnrInfoArray **out_rsrp_snr,
                                    GError **error);

Parses and returns parameters of the 'Signal State' response command in the 'Ms Basic Connect V2' service.

#### Parameters

message | the MbimMessage. |
out_rssi | return location for a guint32, or `NULL` if the 'Rssi' field is not needed. | [out][optional][transfer none]
out_error_rate | return location for a guint32, or `NULL` if the 'ErrorRate' field is not needed. | [out][optional][transfer none]
out_signal_strength_interval | return location for a guint32, or `NULL` if the 'SignalStrengthInterval' field is not needed. | [out][optional][transfer none]
out_rssi_threshold | return location for a guint32, or `NULL` if the 'RssiThreshold' field is not needed. | [out][optional][transfer none]
out_error_rate_threshold | return location for a guint32, or `NULL` if the 'ErrorRateThreshold' field is not needed. | [out][optional][transfer none]
out_rsrp_snr_count | return location for a guint32, or `NULL` if the field is not needed. | [out][optional][transfer none]

out_rsrp_snr

return location for a newly allocated array of MbimRsrpSnrInfo items, or `NULL` if the 'RsrpSnr' field is not needed. The availability of this field is not always guaranteed, and therefore `NULL` may be given as a valid output. Free the returned value with `mbim_rsrp_snr_info_array_free()`.

[out][optional][nullable][transfer full][array zero-terminated=1][element-type MbimRsrpSnrInfo]

error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.28

### mbim_message_ms_basic_connect_v2_signal_state_notification_parse ()

    gboolean
    mbim_message_ms_basic_connect_v2_signal_state_notification_parse
                                   (const MbimMessage *message,
                                    guint32 *out_rssi,
                                    guint32 *out_error_rate,
                                    guint32 *out_signal_strength_interval,
                                    guint32 *out_rssi_threshold,
                                    guint32 *out_error_rate_threshold,
                                    guint32 *out_rsrp_snr_count,
                                    MbimRsrpSnrInfoArray **out_rsrp_snr,
                                    GError **error);

Parses and returns parameters of the 'Signal State' notification command in the 'Ms Basic Connect V2' service.

#### Parameters

message | the MbimMessage. |
out_rssi | return location for a guint32, or `NULL` if the 'Rssi' field is not needed. | [out][optional][transfer none]
out_error_rate | return location for a guint32, or `NULL` if the 'ErrorRate' field is not needed. | [out][optional][transfer none]
out_signal_strength_interval | return location for a guint32, or `NULL` if the 'SignalStrengthInterval' field is not needed. | [out][optional][transfer none]
out_rssi_threshold | return location for a guint32, or `NULL` if the 'RssiThreshold' field is not needed. | [out][optional][transfer none]
out_error_rate_threshold | return location for a guint32, or `NULL` if the 'ErrorRateThreshold' field is not needed. | [out][optional][transfer none]
out_rsrp_snr_count | return location for a guint32, or `NULL` if the field is not needed. | [out][optional][transfer none]

out_rsrp_snr

return location for a newly allocated array of MbimRsrpSnrInfo items, or `NULL` if the 'RsrpSnr' field is not needed. The availability of this field is not always guaranteed, and therefore `NULL` may be given as a valid output. Free the returned value with `mbim_rsrp_snr_info_array_free()`.

[out][optional][nullable][transfer full][array zero-terminated=1][element-type MbimRsrpSnrInfo]

error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.28

## Types and Values

### MbimRsrpSnrInfo

    typedef struct {
        guint32 rsrp;
        guint32 snr;
        guint32 rsrp_threshold;
        guint32 snr_threshold;
        guint32 system_type;
    } MbimRsrpSnrInfo;

A MbimRsrpSnrInfo element.

#### Members

guint32 `rsrp`; | a guint32. |
guint32 `snr`; | a guint32. |
guint32 `rsrp_threshold`; | a guint32. |
guint32 `snr_threshold`; | a guint32. |
guint32 `system_type`; | a MbimDataClass given as a guint32. |

Since: 1.28

### MbimRsrpSnrInfoArray

    typedef MbimRsrpSnrInfo *MbimRsrpSnrInfoArray;

A NULL-terminated array of MbimRsrpSnrInfo elements.

Since: 1.28